org 0x7c00 ; load addr
use16
;START
	mov [bootdrv], dl
	
	xor ax, ax
	cli
	mov ss, ax
	mov sp, 0x8000 ; stack addr
	sti
	
	mov bx, start_message
	call print
	jmp disk_load

LOAD_ADDRESS equ 0x9000
bootdrv:db 0
sectors_to_read:db 1
start_sector:db 2
start_message:db "TestOS bootloader",0
kernel_loaded:db "Kernel loaded ! Will print X",0

include "print.asm"
include "disk.asm"
include "gdt.asm"

back_from_diskload:
	mov bx, kernel_loaded
	call print
	
	; TO 32-bit protected mode
	cli
	lgdt [gdt_descriptor]
	mov eax, cr0
	or eax, 0x1
	mov cr0, eax
	jmp CODE_SEGMENT:init_protected_mode ; "far" jump

use32
init_protected_mode:
	mov ax, DATA_SEGMENT
	mov ds, ax
	mov ss, ax
	mov es, ax
	mov fs, ax
	mov gs, ax
	
	mov edx, 0xb8000
	mov al, [LOAD_ADDRESS]
	mov ah, 0xf0
	mov [edx], ax
	jmp $
	;jmp LOAD_ADDRESS ; bootloader exit

times 510-($-$$) db 0
dw 0xaa55
; sector 2
db "X"