disk_load:
	pusha
	mov [disk_errors_count], word 0

disk_load_internal:
	mov bx, disk_operation
	mov [message_addr], bx

	mov ah, 0x02 ; read sector mode
	mov al, [sectors_to_read]
	mov ch, 0 ; cylinder
	mov cl, [start_sector] ; sector
	mov dh, 0 ; head
	mov dl, [bootdrv]
	
	mov bx, 0
	mov es, bx
	mov bx, LOAD_ADDRESS
	int 0x13
	jc disk_error
	
	
    cmp al, [sectors_to_read]
    jne sectors_error
	
disk_load_end:
	popa
	jmp back_from_diskload

sectors_error:
	mov bx, 0
	mov bl, [sectors_to_read]
	sub bl, al
	mov ah, bl
	mov bx, sectors_operation
	mov [message_addr], bx
	jmp disk_error

disk_tries:db "Disk load, error count :",0
disk_errors_count:dw 0

reset_operation:db "Disk reset",0
disk_operation:db "Disk access",0
controller_operation:db "Controller reset",0
sectors_operation:db "Sectors count"
error_msg:db "Error: ",0
disk_fail:db "3 disk errors, hanging.",0

disk_error:
	mov [error_code], ah
	mov bx, error_msg
	call print_without_line
	call debug
	
	mov bx, [disk_errors_count]
	inc bx
	mov [disk_errors_count], bx
	
	cmp bx, 3
	jnge disk_load_internal
	
	mov bx, disk_fail
	call print
	
	jmp $